//+------------------------------------------------------------------+
//|                                                BalanceMinute.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, S.Boykov (Mislaid)"
#property link      "E-mail: fort-ino@yandex.ru"

#property indicator_separate_window
#property  indicator_buffers 1

// ZeroPoint -      ,     . 
//    .
//       : 
// <  6 ><><   ( 0.01 )> 
//          .
//  :           , 
//    ,   . 
//      .     . 
//    :
//      ->   -> BalanceMinute ->  ->  -> 

//---- indicator buffers
double     b0[];
//---- input parametrs
extern int    ZeroPoint = 1440;
extern string Pair1 = "EURUSD 1";
extern string Pair2 = "AUDUSD -1";
extern string Pair3;
extern string Pair4;
extern string Pair5;
extern string Pair6;
extern string Pair7;
extern string Pair8;

//---- global variables
int    TotalPairs;
string Pairs[8];
double PairLots[8];
double StartPrices[8];
double TickValues[8];
string IndicatorName = "BalanceMinute";
bool   FirstStart;
datetime StartTime, CurrentTime;

//    
   int SymbolNumber;
//   ,     7 
   string SymbolList = "EURUSD GBPUSD AUDUSD EURGBP USDJPY EURJPY GBPJPY AUDJPY CHFJPY CADJPY EURAUD GBPAUD USDCHF EURCHF GBPCHF AUDCHF CADCHF USDCAD EURCAD GBPCAD AUDCAD NZDUSD EURNZD GBPNZD NZDJPY AUDNZD NZDCHF NZDCAD ";
 
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   FirstStart = true;
//---- indicators
   IndicatorBuffers(1);
   IndicatorDigits(2);
//---- 1 indicator buffer mapping
   if(!SetIndexBuffer(0,b0)) Print("cannot set indicator buffers!");
   SetIndexStyle( 0, DRAW_LINE, STYLE_SOLID, 2, LimeGreen);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName(IndicatorName);   
   SetIndexLabel( 0, IndicatorName);
   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if (FirstStart) CountArrays();
   if (Time[0] <= CurrentTime) return(0);
   CurrentTime = Time[0];
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) return(-1);

   int i, limit;
   limit = MathMin( ZeroPoint-2, Bars-counted_bars) + 1;
   
   for(i = limit; i >= 0; i--)
      b0[ i ] = 0.7 * b0[ i+1 ] + 0.3 * IndicatorCount( i );
//----
   return(0);
}
//+------------------------------------------------------------------+

void CountArrays()
{
   StartTime = Time[ZeroPoint-1];
   CurrentTime   = StartTime;
   CheckSymbolList();
   TotalPairs = -1;
   SetParameter(Pair1);
   SetParameter(Pair2);
   SetParameter(Pair3);
   SetParameter(Pair4);
   SetParameter(Pair5);
   SetParameter(Pair6);
   SetParameter(Pair7);
   SetParameter(Pair8);  
   FirstStart = false; 
   b0[ZeroPoint] = 0.0;                
}

void CheckSymbolList()
{
// ,  ,   
   int err;
   double r;
   int i;
   string SymbolName;
   
   string ActualSymbolList = "";
   SymbolNumber   = (StringLen(SymbolList) + 1) / 7; // +1,    
   for (i = 0; i < SymbolNumber; i++)
   {
      SymbolName = StringSubstr( SymbolList, 7 * i, 6);
      r = MarketInfo( SymbolName, MODE_BID); // MarketInfo()
      err = GetLastError();
      if ( err == 4106)
         Print( i, "  4106 -   ", SymbolName);
      else
         ActualSymbolList = ActualSymbolList + SymbolName + " ";
   }
   SymbolList = ActualSymbolList;
   SymbolNumber = StringLen(SymbolList) / 7;
}

void    SetParameter(string Pair)
{
   string SymbolName;
   double SymbolNameLots;
   int    ParameterLength = StringLen( Pair );
   double ratio, digits;
   if (ParameterLength < 7) return;
   SymbolName = StringSubstr( Pair, 0, 6);
   if (StringFind( SymbolList, SymbolName) < 0) return; //incorrect name
   SymbolNameLots = StrToDouble( StringSubstr( Pair, 6) );
   if (MathAbs( SymbolNameLots ) < 0.00001) return; //incorrect value
// Pair input is correct
   digits = MarketInfo( SymbolName, MODE_DIGITS);
   ratio = MathExp( (digits - 2) * MathLog( 10.0 ) );
   Print( SymbolName, " ", SymbolNameLots);
   TotalPairs++;
   Pairs[TotalPairs] = SymbolName;
   PairLots[TotalPairs] = SymbolNameLots;
   StartPrices[TotalPairs] = LastKnownPrice( SymbolName, StartTime);
   TickValues[TotalPairs] = MarketInfo( SymbolName, MODE_TICKVALUE) * SymbolNameLots * ratio;
}
//+------------------------------------------------------------------+
double  LastKnownPrice( string SymbolName, datetime cTime)
{
   int   shift;
   
   shift = iBarShift( SymbolName, 0, cTime, false);
   if (iTime(SymbolName, 0, shift) > cTime) shift++;
   return( iClose(SymbolName, 0, shift) );
}

//+------------------------------------------------------------------+
double IndicatorCount( int shift)
{
   double sum;
   datetime curtime = Time[shift];
   int i;
   for (i = TotalPairs; i >= 0; i--)
      sum+= (LastKnownPrice( Pairs[i], curtime) - StartPrices[i]) * TickValues[i];
   return(sum);
}